Gecode::Set::Branch::ExcNGL Class Reference

No-good literal for exclusion. More...

`#include <branch.hh>`

## Public Member Functions

| ExcNGL (Space &home, SetView x, int n)
| Constructor for creation.
| ExcNGL (Space &home, ExcNGL &ngl)
| Constructor for cloning ngl.
virtual NGL::Status | status (const Space &home) const
| Test the status of the no-good literal.
virtual ExecStatus | prune (Space &home)
| Propagate the negation of the no-good literal.
virtual NGL * | copy (Space &home)
| Create copy.
Public Member Functions inherited from Gecode::ViewValNGL< SetView, int, PC_SET_ANY >
| ViewValNGL (Space &home, SetView x, int n)
| Initialize for propagator p with view x and value n.
virtual void | subscribe (Space &home, Propagator &p)
| Create subscription for no-good literal.
virtual void | cancel (Space &home, Propagator &p)
| Cancel subscription for no-good literal.
virtual void | reschedule (Space &home, Propagator &p)
| Schedule propagator p.
virtual size_t | dispose (Space &home)
| Dispose.
Public Member Functions inherited from Gecode::NGL
| NGL (void)
| Constructor for creation.
| NGL (Space &home)
| Constructor for creation.
| NGL (Space &home, NGL &ngl)
| Constructor for cloning ngl.
virtual bool | notice (void) const
| Whether dispose must always be called (returns false).
bool | leaf (void) const
| Test whether literal is a leaf.
NGL * | next (void) const
| Return pointer to next literal.
void | leaf (bool l)
| Mark literal as leaf or not.
void | next (NGL *n)
| Set pointer to next literal
NGL * | add (NGL *n, bool l)
| Add node n and mark it as leaf l and return n.
virtual | ~NGL (void)
| To avoid warnings.

## Additional Inherited Members

Public Types inherited from Gecode::NGL
enum | Status { FAILED , SUBSUMED , NONE }
| The status of a no-good literal. More...
static void * | operator new (size_t s, Space &home)
| Allocate memory from space.
static void | operator delete (void *s, Space &home)
| Return memory to space.
static void | operator delete (void *p)
| Needed for exceptions.
static void * | operator new (size_t s)
| Not used.
Protected Attributes inherited from Gecode::ViewValNGL< SetView, int, PC_SET_ANY >
SetView | x
| The stored view.
int | n
| The stored value.

## Detailed Description

No-good literal for exclusion.

Definition at line 319 of file branch.hh.

## Constructor & Destructor Documentation

## ExcNGL() [1/2]

Gecode::Set::Branch::ExcNGL::ExcNGL | ( | Space & | home,
|  | SetView | x,
|  | int | n )

inline

Constructor for creation.

Definition at line 44 of file ngl.hpp.

## ExcNGL() [2/2]

Gecode::Set::Branch::ExcNGL::ExcNGL | ( | Space & | home,
|  | ExcNGL & | ngl )

inline

Constructor for cloning ngl.

Definition at line 47 of file ngl.hpp.

## Member Function Documentation

## status()

NGL::Status Gecode::Set::Branch::ExcNGL::status | ( | const Space & | home | ) | const

virtual

Test the status of the no-good literal.

Implements Gecode::NGL.

Definition at line 62 of file ngl.cpp.

## prune()

ExecStatus Gecode::Set::Branch::ExcNGL::prune | ( | Space & | home | ) |

virtual

Propagate the negation of the no-good literal.

Implements Gecode::NGL.

Definition at line 71 of file ngl.cpp.

## copy()

NGL * Gecode::Set::Branch::ExcNGL::copy | ( | Space & | home | ) |

virtual

Create copy.

Implements Gecode::NGL.

Definition at line 58 of file ngl.cpp.

The documentation for this class was generated from the following files:

- gecode/set/branch.hh
- gecode/set/branch/ngl.cpp
- gecode/set/branch/ngl.hpp